unit ZipModule;

interface

uses Classes, Registry, WinDows, SysUtils, RunAppModule;

type
  TZipModule = class(TThread)
    private
      FZipFileName: string;
      FZipInstalled: boolean;
      procedure CheckWinZipInstalled;
    public
      constructor Create; reintroduce;
      procedure CreateZipFile(ZipDest, Archivo: string);
      procedure UpdateZipFile(Dest, Archivo: string);
    published
      property ZipInstalled: boolean read FZipInstalled;
      property ZipFileName: string read FZipFileName;
  end;

implementation

constructor TZipModule.Create;
begin
  inherited Create(True);
    FreeOnTerminate:= True;
    CheckWinZipInstalled;
end;

procedure TZipModule.CheckWinZipInstalled;
var
Reg: TRegistry;
begin
   FZipFileName:= EmptyStr;
    Reg:= TRegistry.Create;
    Reg.RootKey:= HKEY_LOCAL_MACHINE;
    Reg.OpenKey('SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\WinZip', false);
    FZipFileName:=Reg.ReadString('InstallLocation');
    FZipFileName:=ExtractFilePath(FZipFileName);
    FZipFileName:=FZipFileName + 'winzip32.exe';

      if FileExists(FZipFileName)=false then begin
        FZipFileName:= EmptyStr;
        FZipInstalled:= false;
      end else
        FZipInstalled:= true;
end;

procedure TZipModule.CreateZipFile(ZipDest: string; Archivo: string);
var
cmd: string;
begin
   if FZipInstalled = false then exit;
   if FileExists(archivo) = false then exit;
   cmd:= ' -min -a ' + ZipDest + ' ' + Archivo;
   TRunAppModule.Create(FZipFileName, cmd, false);
end;

procedure TZipModule.UpdateZipFile(Dest: string; Archivo: string);
var
cmd: string;
begin
   if FZipInstalled = false then exit;
   if FileExists(Archivo) = false then exit;
   cmd:= ' -min -u ' + Dest + ' ' + Archivo;
   TRunAppModule.Create(FZipFileName, cmd, false);
end;

end.
